%define qt_version 2.3.0

Name: kdenetwork
Version: 2.2.2
Release: 3.1
Prefix: /usr
Summary: Networking applications for KDE.
Epoch: 7
Group: Applications/Internet
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
License: GPL
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{version}.tar.bz2
Source1: kppp.pamd
Source2: kisdndock-1.0.0.tar.bz2
Source3: kimon-2.0pre1.tar.gz
Source4: kisdndock.pam

Patch0: kimon-2.0pre1-misc.patch
Patch1: kdenetwork-2.2beta1-knewsticker-utf8-20010713.diff
Patch2: kisdndock.patch
Patch3: kdenetwork-2.2.2-lanbrowsing.patch

# Security fixes
# Multiple buffer overflows exist in the KDE LAN browsing implementation
Patch100: post-2.2.2-kdenetwork.diff
# CAN-2005-0205 kppp local domain name hijacking
Patch101: kdenetwork-2.2.2-kppp-CAN-2005-0205.patch

Obsoletes: kimon
Obsoletes: kisdndock
Obsoletes: kdenetwork2

Requires: qt >= %{qt_version}
Requires: kdelibs >= 2.2
Requires: XFree86
Requires: XFree86-libs
Requires: glibc
Requires(post,postun): /sbin/ldconfig

%ifnarch s390 s390x
Requires: usermode
%endif

BuildRequires: qt-devel
BuildRequires: kdelibs-devel
BuildRequires: XFree86-devel
BuildRequires: glibc-devel
BuildRequires: gcc-c++

%package ppp
Summary: PPP configuration utilities for KDE.
Group: Applications/Internet
Requires: usermode

%description
The K Desktop Environment (KDE) is a GUI desktop for the X Window
System. The kdenetwork package contains network applications for KDE,
including: kmail, a mail client; korn, another mailbox monitoring
tool; ktalkd, a talk daemon; and ksirc, an irc client.

%description ppp
The kdenetwork-ppp package contains the utilities needed to configure
a PPP (modem dial-up) connection for the K Desktop Environment (KDE).

%prep
%ifnarch s390 s390x
%setup -q -a 2 -a 3
%patch0 -p0 -b .misc
%patch2 -p0 -b .isdn
%else
%setup -q
%endif
%patch1 -p1 -b .utf8
%patch3 -p1 -b .lisa

# security fixes
%patch100 -p1 -b .sec
%patch101 -p1 -b .CAN-2005-0205

%ifnarch s390 s390x
pushd kisdndock
make -f Makefile.cvs
popd
%endif

make -f Makefile.cvs

%build
export KDEDIR=%{prefix}
export LANG=C
unset QTDIR || : ; . /etc/profile.d/qt.sh
FLAGS="-D_GNU_SOURCE"

%ifnarch s390 s390x
pushd kisdndock
CXXFLAGS="$RPM_OPT_FLAGS $FLAGS" \
./configure \
   --prefix=%{prefix} \
   --sysconfdir=%{_sysconfdir}
make %{?_smp_mflags}
popd

pushd kimon-2.0pre1
CXXFLAGS="$RPM_OPT_FLAGS $FLAGS" \
./configure \
   --prefix=%{prefix}
make %{?_smp_mflags}
popd
%endif

cp -a /usr/share/libtool/l* .
%ifnarch alpha
CFLAGS="$FLAGS $RPM_OPT_FLAGS -DNDEBUG -DNO_DEBUG" \
CXXFLAGS="$FLAGS $RPM_OPT_FLAGS -DNDEBUG -DNO_DEBUG -fno-check-new" \
%else
CFLAGS="$FLAGS" \
CXXFLAGS="$FLAGS" \
%endif
./configure \
   --prefix=%{prefix} \
   --includedir=%{prefix}/include/kde

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

%ifnarch s390 s390x
pushd kisdndock
make install DESTDIR=$RPM_BUILD_ROOT transform=
popd

pushd kimon-2.0pre1
make install-strip DESTDIR=$RPM_BUILD_ROOT
popd

mkdir -p $RPM_BUILD_ROOT%{prefix}/bin \
         $RPM_BUILD_ROOT/etc/pam.d \
         $RPM_BUILD_ROOT/etc/security/console.apps

install -m 0644 %{SOURCE4} $RPM_BUILD_ROOT/etc/pam.d/kisdndock
touch $RPM_BUILD_ROOT/etc/security/console.apps/kisdndock

pushd $RPM_BUILD_ROOT%{prefix}/bin
ln -fs consolehelper kisdndock
popd
%endif

make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
cp %{SOURCE1} $RPM_BUILD_ROOT/etc/pam.d/kppp
rm -f $RPM_BUILD_ROOT/kimon.xpm

%ifnarch ia64
# Make symlinks relative
(
  mkdir -p $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en/common
  pushd $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en
  for i in *; do
    [ -d $i -a -L $i/common ] && ln -nfs ../common $i
  done
  popd
)
%endif

cd $RPM_BUILD_ROOT
find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
	$RPM_BUILD_DIR/file.list.%{name}

find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
	-e '/\/config\//s|^|%config|' >> \
	$RPM_BUILD_DIR/file.list.%{name}

find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
	$RPM_BUILD_DIR/file.list.%{name}

egrep -v "(%{prefix}/bin/kppp|%{prefix}/share/applnk/Internet/.*ppp.*|%{prefix}/share/apps/.*ppp.*|%{prefix}/share/icons/.*/.*/.*/.*ppp.*|%{_docdir}/HTML/en/kppp|%{prefix}/bin$|%{prefix}/include$|%{prefix}/lib$|%{prefix}/share$|pam.d/kppp|/etc$|/etc/pam.d$|%{prefix}/share/doc$|%{prefix}/share/icons$|%{prefix}/share/services$|%{prefix}/share/sounds$|%{prefix}/include/kde$|%{prefix}/lib/kde2$|%{prefix}/share/applnk/Internet$|%{prefix}/include/kde/mimelib$|%{prefix}/share/applnk$|%{prefix}/share/apps$|%{prefix}/share/applnk/Settings$|%{prefix}/share/applnk/Utilities$|%{prefix}/share/apps/kconf_update$|%{prefix}/share/config$|%{prefix}/share/doc/HTML$|%{prefix}/share/doc/HTML/en$|%{prefix}/share/icons/hicolor$|%{prefix}/share/icons/hicolor/(16x16|32x32|48x48)$|%{prefix}/share/icons/hicolor/(16x16|32x32|48x48)/apps$|/etc/security/console.apps/kisdndock|/etc/pam.d/kisdndock|%{prefix}/sbin$)" $RPM_BUILD_DIR/file.list.%{name} >$RPM_BUILD_DIR/file.list.%{name}.main
perl -pi -e "s,%{_docdir},%%doc %{_docdir},g" file.list.%{name}.main

# Run kppp through consolehelper
mkdir -p $RPM_BUILD_ROOT%{prefix}/sbin
mv $RPM_BUILD_ROOT%{prefix}/bin/kppp $RPM_BUILD_ROOT%{prefix}/sbin
ln -s consolehelper $RPM_BUILD_ROOT%{prefix}/bin/kppp
mkdir -p $RPM_BUILD_ROOT/etc/security/console.apps
cat >$RPM_BUILD_ROOT/etc/security/console.apps/kppp <<EOF
USER=root
PROGRAM=/usr/sbin/kppp
SESSION=true
EOF

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}* $RPM_BUILD_DIR/%{name} 

%files -f ../file.list.%{name}.main
%defattr(-,root,root)
%config /etc/pam.d/kisdndock
%config /etc/security/console.apps/kisdndock

%ifnarch s390 s390x
%files ppp
%defattr(-,root,root)
%{prefix}/bin/kppp*
%{prefix}/sbin/kppp
%{prefix}/share/applnk/Internet/*ppp*
%{prefix}/share/apps/*ppp*
%{prefix}/share/icons/*/*/*/*ppp*
%doc %{_docdir}/HTML/en/kppp
%config /etc/security/console.apps/kppp
%config /etc/pam.d/kppp
%endif

%changelog
* Wed Feb 16 2005 Than Ngo <than@redhat.com> 2.2.2-3.1
- Apply patch to fix kppp privileged fd leak vulnerability, CAN-2005-0205, #148912

* Tue Dec 17 2002 Than Ngo <than@redhat.com> 2.2.2-3
- Multiple URL and filename vulnerabilities

* Thu Nov 14 2002 Than Ngo <than@redhat.com> 2.2.2-2
- Multiple buffer overflows exist in the KDE LAN browsing implementation
- fix kisdndock restart problem (bug #56839)

* Thu Nov 15 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2.2-1
- 2.2.2

* Sat Sep 15 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2.1-1
- 2.2.1

* Mon Sep  3 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-6
- Make kisdndock get along with devices geneerated using
  redhat-config-network (#52994)
- Don't build kppp on s390/s390x

* Wed Aug 22 2001 Than Ngo <than@redhat.com> 2.2-5
- fix bug in kisdndock

* Sun Aug 19 2001 Than Ngo <than@redhat.com> 2.2-4
- add some fixes from KDE_2_2_BRANCH
- fix bug #51852, #51788

* Mon Aug 13 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-3
- Add kmail and knode fixes from KDE_2_2_BRANCH (fixes #51634)
- Remove /etc/pam.d/kppp from base package (#51592)

* Wed Aug  8 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-2
- Another kmail fix: don't crash when compacting folders

* Mon Aug  6 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-1
- 2.2 final + kmail fix from KDE_2_2_BRANCH
- Remove ia64 workarounds, no longer needed

* Sun Jul 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010722.1
- Update
- Add build dependencies
- Work around ia64 breakages

* Sun May 13 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010513.1
- Update to CVS
- clean up specfile
- Use %%post -p and %%postun -p

* Wed Feb 21 2001 Than Ngo <than@redhat.com>
- 2.1-respin

* Mon Feb 19 2001 Than Ngo <than@redhat.com>
- update 2.1
- fix dangling symlinks

* Fri Feb  2 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Limit CPU usage to 2 CPUs to make asok happy

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Don't require perl, not everyone using ksirc is also using
  ksirc perl scripting...

* Mon Jan  8 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update (needed because of kdelibs change)
- Obsolete kdenetwork2 (from 7.0 preview)

* Mon Jan  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update

* Tue Dec 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add missing PAM file, fix group

* Wed Nov 15 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update to HEAD 

* Fri Nov  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update CVS (fix kmail segfault with empty identity)

* Tue Oct 31 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up consolehelper config

* Mon Oct 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to current KDE_2_0_BRANCH (this should fix up knode)
- Run kppp through consolehelper (Bug #20021)
- Split of kppp and kppplog to a separate package, kdenetwork-ppp
  (RFE #20022)

* Mon Oct 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 final

* Wed Oct  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0

* Thu Aug 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.93

* Mon Aug  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new version

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- disable keystone for now (compiler problem)

* Fri Jul 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- some fixes to spec file

* Tue Jul 18 2000 Than Ngo <than@redhat.de>
- rebuilt with glibc-2.1.92-14 and gcc-2.96-40

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Obsolete ktalk (powertools 6.x)
- SMPify

* Tue Jul 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use gcc 2.96
- new snapshot

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Epoch

* Tue Jun 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- ExcludeArch ia64 for now

* Sat Mar 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- move it to /usr, where it belongs

* Mon Oct 25 1999 Bernhard Rosenkraenzer <bero@redhat.de>
- initial RPM
